--    Program: 		CAPAREXT_PAYMENT_SCHEDULE.sql
--    Description:  Extract AR Payment Schedule information 
--    Revision:     1st     
--    Parameter: 	1. set of books short name e.g. SOB_C999

set doc off;      
set verify off;
set serveroutput on size 1000000;
whenever sqlerror exit failure rollback;
alter session set nls_date_format='YYYYMMDD HH24:MI:SS';

declare   
   l_processed_count		number;
   l_rejected_count 		number;
   l_err_msg				varchar2(2000);
                    		
   l_utl_file       		utl_file.file_type;
   l_filename       		varchar2(255);
   l_pathname       		varchar2(100);
                    		
   l_ngo_sob				varchar2(20);
   
   l_set_of_books_id		number;
                    		  
   cursor cur_payment_schedule (p_set_of_books_id number) is
      select ps.* 
      from   ar_payment_schedules_all ps,
             hr_organization_information hoi
      where  hoi.org_information_context = 'Operating Unit Information'
      and    hoi.org_information3 = to_char(p_set_of_books_id)
      and    hoi.organization_id = ps.org_id;

begin
   l_pathname := '/tmp';
   l_filename := 'CAPAR_PAYMENT_SCHEDULE.dat';
   l_utl_file := utl_file.fopen(l_pathname, l_filename, 'w');
   
   l_processed_count := 0;
   l_rejected_count  := 0;
   
   l_ngo_sob := '&1';
   
   begin
     select set_of_books_id
     into   l_set_of_books_id
     from   gl_sets_of_books
     where  upper(short_name) = upper(l_ngo_sob);
   exception
     when others then
       dbms_output.put_line(l_ngo_sob||': set of books name not found');
       --raise;
   end;      

   for cur in cur_payment_schedule(l_set_of_books_id) loop   	
     
     -- output data 
     utl_file.put_line( l_utl_file, 
       cur.PAYMENT_SCHEDULE_ID             || chr(9) ||
       cur.STAGED_DUNNING_LEVEL            || chr(9) ||
       cur.DUNNING_LEVEL_OVERRIDE_DATE     || chr(9) ||
       cur.LAST_UPDATE_DATE                || chr(9) ||
       cur.LAST_UPDATED_BY                 || chr(9) ||
       cur.CREATION_DATE                   || chr(9) ||
       cur.CREATED_BY                      || chr(9) ||
       cur.LAST_UPDATE_LOGIN               || chr(9) ||
       cur.DUE_DATE                        || chr(9) ||
       cur.AMOUNT_DUE_ORIGINAL             || chr(9) ||
       cur.AMOUNT_DUE_REMAINING            || chr(9) ||
       cur.NUMBER_OF_DUE_DATES             || chr(9) ||
       cur.STATUS                          || chr(9) ||
       cur.INVOICE_CURRENCY_CODE           || chr(9) ||
       cur.CLASS                           || chr(9) ||
       cur.CUST_TRX_TYPE_ID                || chr(9) ||
       cur.CUSTOMER_ID                     || chr(9) ||
       cur.CUSTOMER_SITE_USE_ID            || chr(9) ||
       cur.CUSTOMER_TRX_ID                 || chr(9) ||
       cur.CASH_RECEIPT_ID                 || chr(9) ||
       cur.ASSOCIATED_CASH_RECEIPT_ID      || chr(9) ||
       cur.TERM_ID                         || chr(9) ||
       cur.TERMS_SEQUENCE_NUMBER           || chr(9) ||
       cur.GL_DATE_CLOSED                  || chr(9) ||
       cur.ACTUAL_DATE_CLOSED              || chr(9) ||
       cur.DISCOUNT_DATE                   || chr(9) ||
       cur.AMOUNT_LINE_ITEMS_ORIGINAL      || chr(9) ||
       cur.AMOUNT_LINE_ITEMS_REMAINING     || chr(9) ||
       cur.AMOUNT_APPLIED                  || chr(9) ||
       cur.AMOUNT_ADJUSTED                 || chr(9) ||
       cur.AMOUNT_IN_DISPUTE               || chr(9) ||
       cur.AMOUNT_CREDITED                 || chr(9) ||
       cur.RECEIVABLES_CHARGES_CHARGED     || chr(9) ||
       cur.RECEIVABLES_CHARGES_REMAINING   || chr(9) ||
       cur.FREIGHT_ORIGINAL                || chr(9) ||
       cur.FREIGHT_REMAINING               || chr(9) ||
       cur.TAX_ORIGINAL                    || chr(9) ||
       cur.TAX_REMAINING                   || chr(9) ||
       cur.DISCOUNT_ORIGINAL               || chr(9) ||
       cur.DISCOUNT_REMAINING              || chr(9) ||
       cur.DISCOUNT_TAKEN_EARNED           || chr(9) ||
       cur.DISCOUNT_TAKEN_UNEARNED         || chr(9) ||
       cur.IN_COLLECTION                   || chr(9) ||
       cur.CASH_APPLIED_ID_LAST            || chr(9) ||
       cur.CASH_APPLIED_DATE_LAST          || chr(9) ||
       cur.CASH_APPLIED_AMOUNT_LAST        || chr(9) ||
       cur.CASH_APPLIED_STATUS_LAST        || chr(9) ||
       cur.CASH_GL_DATE_LAST               || chr(9) ||
       cur.CASH_RECEIPT_ID_LAST            || chr(9) ||
       cur.CASH_RECEIPT_DATE_LAST          || chr(9) ||
       cur.CASH_RECEIPT_AMOUNT_LAST        || chr(9) ||
       cur.CASH_RECEIPT_STATUS_LAST        || chr(9) ||
       cur.EXCHANGE_RATE_TYPE              || chr(9) ||
       cur.EXCHANGE_DATE                   || chr(9) ||
       cur.EXCHANGE_RATE                   || chr(9) ||
       cur.ADJUSTMENT_ID_LAST              || chr(9) ||
       cur.ADJUSTMENT_DATE_LAST            || chr(9) ||
       cur.ADJUSTMENT_GL_DATE_LAST         || chr(9) ||
       cur.ADJUSTMENT_AMOUNT_LAST          || chr(9) ||
       cur.FOLLOW_UP_DATE_LAST             || chr(9) ||
       cur.FOLLOW_UP_CODE_LAST             || chr(9) ||
       cur.PROMISE_DATE_LAST               || chr(9) ||
       cur.PROMISE_AMOUNT_LAST             || chr(9) ||
       cur.COLLECTOR_LAST                  || chr(9) ||
       cur.CALL_DATE_LAST                  || chr(9) ||
       cur.TRX_NUMBER                      || chr(9) ||
       cur.TRX_DATE                        || chr(9) ||
       cur.ATTRIBUTE_CATEGORY              || chr(9) ||
       cur.ATTRIBUTE1                      || chr(9) ||
       cur.ATTRIBUTE2                      || chr(9) ||
       cur.ATTRIBUTE3                      || chr(9) ||
       cur.ATTRIBUTE4                      || chr(9) ||
       cur.ATTRIBUTE5                      || chr(9) ||
       cur.ATTRIBUTE6                      || chr(9) ||
       cur.ATTRIBUTE7                      || chr(9) ||
       cur.ATTRIBUTE8                      || chr(9) ||
       cur.ATTRIBUTE9                      || chr(9) ||
       cur.ATTRIBUTE10                     || chr(9) ||
       cur.REVERSED_CASH_RECEIPT_ID        || chr(9) ||
       cur.AMOUNT_ADJUSTED_PENDING         || chr(9) ||
       cur.ATTRIBUTE11                     || chr(9) ||
       cur.ATTRIBUTE12                     || chr(9) ||
       cur.ATTRIBUTE13                     || chr(9) ||
       cur.ATTRIBUTE14                     || chr(9) ||
       cur.ATTRIBUTE15                     || chr(9) ||
       cur.GL_DATE                         || chr(9) ||
       cur.ACCTD_AMOUNT_DUE_REMAINING      || chr(9) ||
       cur.PROGRAM_APPLICATION_ID          || chr(9) ||
       cur.PROGRAM_ID                      || chr(9) ||
       cur.PROGRAM_UPDATE_DATE             || chr(9) ||
       cur.RECEIPT_CONFIRMED_FLAG          || chr(9) ||
       cur.REQUEST_ID                      || chr(9) ||
       cur.SELECTED_FOR_RECEIPT_BATCH_ID   || chr(9) ||
       cur.LAST_CHARGE_DATE                || chr(9) ||
       cur.SECOND_LAST_CHARGE_DATE         || chr(9) ||
       cur.DISPUTE_DATE                    || chr(9) ||
       cur.ORG_ID                          || chr(9) ||
       cur.GLOBAL_ATTRIBUTE1               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE2               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE3               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE4               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE5               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE6               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE7               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE8               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE9               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE10              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE11              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE12              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE13              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE14              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE15              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE16              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE17              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE18              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE19              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE20              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE_CATEGORY       || chr(9) ||
       cur.CONS_INV_ID                     || chr(9) ||
       cur.CONS_INV_ID_REV                 || chr(9) ||
       cur.EXCLUDE_FROM_DUNNING_FLAG       || chr(9) ||
       cur.MRC_CUSTOMER_TRX_ID             || chr(9) ||
       cur.MRC_EXCHANGE_RATE_TYPE          || chr(9) ||
       cur.MRC_EXCHANGE_DATE               || chr(9) ||
       cur.MRC_EXCHANGE_RATE               || chr(9) ||
       cur.MRC_ACCTD_AMOUNT_DUE_REMAINING  || chr(9) ||
       cur.BR_AMOUNT_ASSIGNED              || chr(9) ||
       cur.RESERVED_TYPE                   || chr(9) ||
       cur.RESERVED_VALUE                  
	 );                        
                               
	 l_processed_count := l_processed_count + 1;
   end loop;

   if l_processed_count = 0 then   
     l_rejected_count := l_rejected_count + 1;
     l_err_msg := l_ngo_sob || ': AR Payment Schedule not found';
   end if;
   
   -- insert into log table
   insert into capcnv_log ( prog_id,process_date, record_processed,record_rejected,record_extracted,err_msg) 
    values ('CAPAREXT_PAYMENT_SCHEDULE', sysdate, l_processed_count, l_rejected_count, l_processed_count-l_rejected_count, l_err_msg );
   
   commit;

   utl_file.fclose(l_utl_file);
exception 
  when others then
    dbms_output.put_line(sqlerrm);
    rollback;  
end;
/

--exit
